/// <reference types="node" />
import * as pdu from "../pdu";
/** Modbus RTU request. */
export declare class Request extends pdu.Request {
    readonly slaveAddress: number;
    readonly functionCode: number;
    readonly buffer: Buffer;
    constructor(slaveAddress: number, functionCode: number, buffer: Buffer);
}
/** Modbus RTU response. */
export declare class Response extends pdu.Response {
    readonly slaveAddress: number;
    readonly functionCode: number;
    readonly data: any;
    readonly buffer: Buffer;
    constructor(slaveAddress: number, functionCode: number, data: any, buffer: Buffer);
}
/** Modbus RTU exception. */
export declare class Exception extends pdu.Exception {
    readonly slaveAddress: number;
    readonly functionCode: number;
    readonly exceptionFunctionCode: number;
    readonly exceptionCode: number;
    readonly buffer: Buffer;
    constructor(slaveAddress: number, functionCode: number, exceptionFunctionCode: number, exceptionCode: number, buffer: Buffer);
}
