/// <reference types="node" />
import { Socket } from "net";
import { Server } from "./server";
/** Modbus TCP server mock for testing. */
export declare class MockServer extends Server {
    readCoils(startingAddress: number, quantityOfCoils: number): boolean[];
    readDiscreteInputs(startingAddress: number, quantityOfInputs: number): boolean[];
    readHoldingRegisters(startingAddress: number, quantityOfRegisters: number): number[];
    readInputRegisters(startingAddress: number, quantityOfRegisters: number): number[];
    writeSingleCoil(outputAddress: number, outputValue: boolean): boolean;
    writeSingleRegister(registerAddress: number, registerValue: number): number;
    writeMultipleCoils(startingAddress: number, outputValues: boolean[]): number;
    writeMultipleRegisters(startingAddress: number, registerValues: number[]): number;
    readBits(startingAddress: number, quantityOfBits: number): boolean[];
    readRegisters(startingAddress: number, quantityOfRegisters: number): number[];
}
/** Emulate a Modbus TCP server with slow response time. */
export declare class MockSlowServer extends MockServer {
    protected writeSocket(socket: Socket, packet: Buffer): void;
}
/** Emulate a Modbus TCP server which drops 2/3 of packets. */
export declare class MockDropServer extends MockServer {
    protected dropCounter: number;
    protected writeSocket(socket: Socket, packet: Buffer): void;
}
