"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var server_1 = require("./server");
/** Modbus TCP server mock for testing. */
var MockServer = /** @class */ (function (_super) {
    __extends(MockServer, _super);
    function MockServer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MockServer.prototype.readCoils = function (startingAddress, quantityOfCoils) {
        return this.readBits(startingAddress, quantityOfCoils);
    };
    MockServer.prototype.readDiscreteInputs = function (startingAddress, quantityOfInputs) {
        return this.readBits(startingAddress, quantityOfInputs);
    };
    MockServer.prototype.readHoldingRegisters = function (startingAddress, quantityOfRegisters) {
        return this.readRegisters(startingAddress, quantityOfRegisters);
    };
    MockServer.prototype.readInputRegisters = function (startingAddress, quantityOfRegisters) {
        return this.readRegisters(startingAddress, quantityOfRegisters);
    };
    MockServer.prototype.writeSingleCoil = function (outputAddress, outputValue) {
        return outputValue;
    };
    MockServer.prototype.writeSingleRegister = function (registerAddress, registerValue) {
        return registerValue;
    };
    MockServer.prototype.writeMultipleCoils = function (startingAddress, outputValues) {
        return outputValues.length;
    };
    MockServer.prototype.writeMultipleRegisters = function (startingAddress, registerValues) {
        return registerValues.length;
    };
    MockServer.prototype.readBits = function (startingAddress, quantityOfBits) {
        var values = [];
        for (var i = 0; i < quantityOfBits; i++) {
            values.push(i % 2 === 0);
        }
        return values;
    };
    MockServer.prototype.readRegisters = function (startingAddress, quantityOfRegisters) {
        var values = [];
        for (var i = 0; i < quantityOfRegisters; i++) {
            values.push(0xafaf);
        }
        return values;
    };
    return MockServer;
}(server_1.Server));
exports.MockServer = MockServer;
/** Emulate a Modbus TCP server with slow response time. */
var MockSlowServer = /** @class */ (function (_super) {
    __extends(MockSlowServer, _super);
    function MockSlowServer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MockSlowServer.prototype.writeSocket = function (socket, packet) {
        setTimeout(function () {
            socket.write(packet);
        }, 3000);
    };
    return MockSlowServer;
}(MockServer));
exports.MockSlowServer = MockSlowServer;
/** Emulate a Modbus TCP server which drops 2/3 of packets. */
var MockDropServer = /** @class */ (function (_super) {
    __extends(MockDropServer, _super);
    function MockDropServer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.dropCounter = 0;
        return _this;
    }
    MockDropServer.prototype.writeSocket = function (socket, packet) {
        this.dropCounter += 1;
        if (this.dropCounter % 3 === 0) {
            socket.write(packet);
        }
    };
    return MockDropServer;
}(MockServer));
exports.MockDropServer = MockDropServer;
//# sourceMappingURL=mock.js.map