/// <reference types="node" />
import * as pdu from "../pdu";
/** Modbus TCP request. */
export declare class Request extends pdu.Request {
    readonly transactionId: number;
    readonly unitId: number;
    readonly functionCode: number;
    readonly buffer: Buffer;
    constructor(transactionId: number, unitId: number, functionCode: number, buffer: Buffer);
}
/** Modbus TCP response. */
export declare class Response extends pdu.Response {
    readonly transactionId: number;
    readonly unitId: number;
    readonly functionCode: number;
    readonly data: any;
    readonly buffer: Buffer;
    constructor(transactionId: number, unitId: number, functionCode: number, data: any, buffer: Buffer);
}
/** Modbus TCP exception. */
export declare class Exception extends pdu.Exception {
    readonly transactionId: number;
    readonly unitId: number;
    readonly functionCode: number;
    readonly exceptionFunctionCode: number;
    readonly exceptionCode: number;
    readonly buffer: Buffer;
    constructor(transactionId: number, unitId: number, functionCode: number, exceptionFunctionCode: number, exceptionCode: number, buffer: Buffer);
}
